import string

from v6d3music.core.real_url import real_url
from v6d3music.core.ytaservicing import *
from v6d3music.core.ytaudio import YTAudio
from v6d3music.utils.argctx import InfoCtx
from v6d3music.utils.assert_admin import assert_admin
from v6d3music.utils.options_for_effects import options_for_effects
from v6d3music.utils.presets import allowed_effects

from v6d2ctx.context import Context, Explicit, escape


async def create_ytaudio(
        servicing: YTAServicing, ctx: Context, it: InfoCtx
) -> YTAudio:
    assert ctx.member is not None
    if it.effects:
        if it.effects not in allowed_effects:
            assert_admin(ctx.member)
        if not set(it.effects) <= set(string.ascii_letters + string.digits + '*,=+-/()|.^:_'):
            raise Explicit('malformed effects')
        options = options_for_effects(it.effects)
    else:
        options = None
    return YTAudio(
        servicing,
        await real_url(servicing.caching, it.info['url'], False, it.tor),
        it.info['url'],
        f'{escape(it.info.get("title", "unknown"))} `Rby` {ctx.member}',
        options,
        ctx.member,
        it.already_read,
        it.tor
    )
