from typing import Any, Coroutine, TypeVar
from abc import ABC, abstractmethod

T = TypeVar('T')


__all__ = ('AbstractRunner',)


class AbstractRunner(ABC):
    @abstractmethod
    async def run(self, coro: Coroutine[Any, Any, T]) -> T:
        raise NotImplementedError
