import discord.utils
import yt_dlp


def extract(params: dict, url: str, kwargs: dict):
    try:
        extracted = yt_dlp.YoutubeDL(params=params).extract_info(url, **kwargs)
        if not isinstance(extracted, dict):
            raise TypeError
        if 'entries' in extracted:
            extracted['entries'] = list(extracted['entries'])
        return extracted
    except Exception as e:
        msg = str(e)
        msg = discord.utils.escape_markdown(msg)
        msg = msg.replace('\x1b[0;31m', '__')
        msg = msg.replace('\x1b[0m', '__')
        print(msg)
        msg = 'unknown ytdl error'
        return {'__error__': True, '__error_str__': msg}
